

#include <kmainwindow.h>
#include <klocale.h>
#include <kglobal.h>
#include <kiconloader.h>
#include <kpopupmenu.h>
#include <kmessagebox.h>
#include <kaboutapplication.h>
#include <kglobal.h>
#include <kconfig.h>
#include <kconfigdata.h>

#include "khdapsmon.h"
#include "khdapsmonwidget.h"
#include "sysfsparse.h"

#define UPDATE_INTERVAL 500

khdapsmon::khdapsmon()
    : KMainWindow( 0, "khdapsmon" )
    , sysFsParser ( SysFsParse() )
{
    setCentralWidget( new khdapsmonWidget( this ) );

    trayIcon = new KSystemTray(this, "khdapsmon");

    // set up tray icon menu
    trayIcon->contextMenu()->insertItem("About kHdapsMon...", this, SLOT(about()), CTRL+Key_A);

    // Lookup the device we are monitoring
    deviceToMonitor = KGlobal::config()->readEntry("Device","hda");

    updateIcon();
    trayIcon->show();

    // update status every UPDATE_INTERVAL (I set this to 500) ms
    timer = new QTimer(this);
    connect(timer,SIGNAL(timeout()),this,SLOT(updateIcon()));
    timer->start(UPDATE_INTERVAL);
}

khdapsmon::~khdapsmon()
{

    timer->stop();
    delete timer;
    timer = NULL;

    delete trayIcon;
}

void khdapsmon::updateIcon() {
// apparently 'protected' is a reserved keyword in C++ ;-)
int isProtected;

	deviceToMonitor = KGlobal::config()->readEntry("Device","hda");

	isProtected = sysFsParser.isQueueProtected(deviceToMonitor);

	if  ( isProtected == 0 ) {
		trayIcon->setPixmap(trayIcon->loadIcon(HDAPS_ICON_GO));
	} else if ( isProtected == 1 ) {
		trayIcon->setPixmap(trayIcon->loadIcon(HDAPS_ICON_PAUSE));
	} else {
		trayIcon->setPixmap(trayIcon->loadIcon(HDAPS_ICON_ERROR));
	}
}

void khdapsmon::about() {
    KAboutApplication::KAboutApplication(this,"kaboutapplication",TRUE).exec();
}
#include "khdapsmon.moc"

