

#ifndef _KHDAPSMON_H_
#define _KHDAPSMON_H_

#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <kmainwindow.h>
#include <ksystemtray.h>

#include <qpixmap.h>
#include <qtimer.h>

#include "sysfsparse.h"

#define HDAPS_ICON_GO "hdapsgo"
#define HDAPS_ICON_PAUSE "hdapspause"
#define HDAPS_ICON_ERROR "hdapserror"



/**
 * @short Application Main Window
 * @author Andrew Barr <andrew.james.barr@gmail.com>
 * @version 0.1
 */
class khdapsmon : public KMainWindow
{
    Q_OBJECT
public:
    /**
     * Default Constructor
     */
    khdapsmon();

    /**
     * Default Destructor
     */
    virtual ~khdapsmon();

    int isQueueProtected(QString device);
    QString returnAccelCoords();

    KConfig *khConfig;
    QCString deviceToMonitor;


public slots:
    void updateIcon();
    void about();

private:
    KSystemTray *trayIcon;
    QTimer* timer;

    SysFsParse sysFsParser;
};

#endif // _KHDAPSMON_H_
