#include "sysfsparse.h"

SysFsParse::SysFsParse()
: keyb( FALSE ) 
, mous ( FALSE ) { 
}

SysFsParse::~SysFsParse() {
}

// credit to Tobias Roser <le.petit.fou@web.de> for the original code
// for these functions (from KthinkBat -- BatInfo::parseSysfsTP())
int SysFsParse::isQueueProtected(QString device) 
{

QString ptPath = "/sys/block/" + device + "/queue/protect";
QFile file;
QTextStream stream;

     file.setName(ptPath);

     if(file.exists() && file.open(IO_ReadOnly)) {
		stream.setDevice(&file);
		return stream.readLine().toInt(NULL,10);
     }
    else {
	// file doesn't exist or there was a problem opening it
	return -1;
    }

}

QString SysFsParse::returnAccelCoords() {

QFile file;
QTextStream stream;

     file.setName("/sys/devices/platform/hdaps/position");

     if(file.exists() && file.open(IO_ReadOnly)) {
		stream.setDevice(&file);
		return stream.readLine();
     } else {
        return NULL;
    }
}

void SysFsParse::periphrialActivity() {

QString ptKeyboard = "/sys/devices/platform/hdaps/keyboard_activity";
QString ptMouse = "/sys/devices/platform/hdaps/mouse_activity";
QFile fileKeyboard;
QFile fileMouse;
QTextStream streamKeyboard;
QTextStream streamMouse;

     fileKeyboard.setName(ptKeyboard);

     if(fileKeyboard.exists() && fileKeyboard.open(IO_ReadOnly)) {
		streamKeyboard.setDevice(&fileKeyboard);
		keyb = streamKeyboard.readLine().toInt(NULL,10);
     }
     else {
	keyb = FALSE;
     }

     fileMouse.setName(ptMouse);

     if(fileMouse.exists() && fileMouse.open(IO_ReadOnly)) {
		streamMouse.setDevice(&fileMouse);
		mous = streamMouse.readLine().toInt(NULL,10);
     } else {
	mous = FALSE;
     }
}
